﻿package  
{
	import net.flashpunk.Entity;
	import net.flashpunk.utils.Draw;
	import net.flashpunk.Graphic;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.FP;
	import net.flashpunk.Sfx;
	import flash.utils.getDefinitionByName;
	import flash.utils.getQualifiedClassName;

	public class e_Enemy extends Entity
	{
		[Embed(source = 'graphics/ball.png')] private const B:Class;
		[Embed(source = 'sfx/hit.mp3')]	private const HIT:Class;
		[Embed(source = 'sfx/hit1.mp3')]	private const HIT1:Class;
		[Embed(source = 'sfx/hit2.mp3')]	private const HIT2:Class;
		[Embed(source = 'sfx/hit3.mp3')]	private const HIT3:Class;
		[Embed(source = 'sfx/hit4.mp3')]	private const HIT4:Class;

		public var l:* = FP.world as getObjClass(FP.world);
		public var size:Number = 10;
		public var time:Number = 0;
		public var xspeed:Number = 0;
		public var yspeed:Number = 0;
		public var hit:Boolean = false;
		public var a:Number = 1;

		public var ht:Sfx;
		public var ht1:Sfx;
		public var ht2:Sfx;
		public var ht3:Sfx;
		public var ht4:Sfx;
		public var img:Image;

		public function e_Enemy(x2:Number,y2:Number,s:Number,t:Number) {
			type="enemy";
			setHitbox(s*2,s*2,s,s);
			layer=-1;
			
			ht = new Sfx(HIT);
			ht1 = new Sfx(HIT1);
			ht2 = new Sfx(HIT2);
			ht3 = new Sfx(HIT3);
			ht4 = new Sfx(HIT4);
			img=new Image(B);
			img.scale = (s*2)/60;

			x=x2;
			y=y2;
			size=s;
			if (t!=0) {
				time=t;
				xspeed=(400-x)/(t*60);
				yspeed=(300-y)/(t*60);
			}
		}
		
		override public function update():void {
			x+=xspeed*60*FP.getElapsed();
			y+=yspeed*60*FP.getElapsed();

			time-=FP.getElapsed();
			if (time>0 && !hit) {
				xspeed=(400-x)/(time*60);
				yspeed=(300-y)/(time*60);
			} else time=0;

			var p:e_Player = collide("player",x,y) as e_Player;
			if (p && !hit) {
				if (distanceToPoint(p.x,p.y)<=size+p.size) {
					var xc:Number = x+(p.x-x)*(size/distanceToPoint(p.x,p.y));
					var yc:Number = y+(p.y-y)*(size/distanceToPoint(p.x,p.y));
					if (l instanceof l_Level && l.level>=5) {
						l._emitter.emit(xc,yc,xspeed,yspeed);
						l._emitter.emit(xc,yc,p.xspeed,p.yspeed);
						FP.world.add(new e_BgCircle(xc,yc));
					}
					var tx:Number = xspeed;
					var ty:Number = yspeed;
					xspeed = p.xspeed;
					yspeed = p.yspeed;
					p.xspeed = tx;
					p.yspeed = ty;
					if (l.level==6) p.col = 255;
					hit = true;
					if (l.level>=3) hs();
				}
			}
			if (hit) {
				if (l.level==1) FP.world.remove(this);
				else {
					var e:e_Enemy = collide("enemy",x,y) as e_Enemy;
					if (e) {
						if (distanceToPoint(e.x,e.y)<=size+e.size && !e.hit) {
							var xc:Number = x+(e.x-x)*(size/distanceToPoint(e.x,e.y));
							var yc:Number = y+(e.y-y)*(size/distanceToPoint(e.x,e.y));
							if (l instanceof l_Level && l.level>=5) {
								l._emitter.emit(xc,yc,e.xspeed,e.yspeed);
								l._emitter.emit(xc,yc,xspeed,yspeed);
								FP.world.add(new e_BgCircle(xc,yc));
							}
							e.xspeed = xspeed;
							e.yspeed = yspeed;
							e.hit = true;
							if (l.level>=3) hs();
						}
					}
					a-=0.05;
					if (a<=0) FP.world.remove(this);
				}
			}
		}

		override public function render():void {
			if (l.level<=3) {
				if (l.level>1 || !hit) {
					Draw.rect(x-size,y-size/2,size*2,size,0xFFFFFF,a);
					Draw.rect(x-size/2,y-size,size,size*2,0xFFFFFF,a);
				}
			} else {
				img.alpha = a;
				Draw.graphic(img as Graphic,x-size,y-size);
			}
		}

		public function hs():void {
			if (l.level<6) ht.play();
			else {
				var d:Number = Math.round(Math.random()*4)
				if (d==0 || d==4) ht1.play();
				else if (d==1) ht2.play();
				else if (d==2) ht3.play();
				else if (d==3) ht4.play();
			}
		}
	}
}
