﻿package  
{
	import net.flashpunk.Entity;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Draw;
	import net.flashpunk.Graphic;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.FP;
	import flash.utils.getDefinitionByName;
	import flash.utils.getQualifiedClassName;
	
	public class e_Player extends Entity
	{
		[Embed(source = 'graphics/ball.png')] private const B:Class;

		public var l:* = FP.world as getObjClass(FP.world);
		public var radius:Number = 150;
		public var elastic:Number = 0.4;
		public var curvedir:Number = 0;
		public var xspeed:Number = 0;
		public var yspeed:Number = 0;
		public var anchorx:Number = 400;
		public var anchory:Number = 300;
		public var size:Number = 24;

		public var activated:Boolean = true;

		public var img:Image;
		public var col:Number = 120;

		public function e_Player(xp:Number=400,yp:Number=300,xs:Number=0,ys:Number=0,ax:Number=400,ay:Number=300,a:Boolean=true) {
			type="player";
			setHitbox(48,48,24,24);
			layer=-1;

			img=new Image(B);
			img.color=FP.getColorRGB(col,col,col);
			img.scale = (size*2)/60;

			if (l.level==1) radius=0;
			else if (l.level==2) radius=75;
			else radius=150;
			
			x=xp;
			y=yp;
			xspeed=xs;
			yspeed=ys;
			anchorx=ax;
			anchory=ay;

			activated=a;
		}
		
		override public function update():void {
			if (radius==0) {
				if (activated) {
					x = Input.mouseX;
					y = Input.mouseY;
				} else if (distanceToPoint(Input.mouseX,Input.mouseY)<150) {
					activated=true;
				}
			} else {
				if (activated) {
					x+=xspeed*60*FP.getElapsed();
					y+=yspeed*60*FP.getElapsed();
					xspeed*=0.99;
					//yspeed+=0.5;
					yspeed*=0.99;
					if (col>120) col-=3;
					FP.console.log(col);
					img.color=FP.getColorRGB(col,col,col);

					if (distanceToPoint(anchorx,anchory)>radius) {
						while (distanceToPoint(anchorx,anchory)>radius) moveTowards(anchorx,anchory,1);
						var speed:Number = Math.sqrt(Math.abs(xspeed)+Math.abs(yspeed))*5;
						var xpart:Number = (x-anchorx)/(Math.abs(x-anchorx)+Math.abs(y-anchory))*-1;
						var ypart:Number = (y-anchory)/(Math.abs(x-anchorx)+Math.abs(y-anchory))*-0.3;
						xspeed = xpart*speed*elastic;
						yspeed = ypart*speed*elastic;
						if (y<anchory) curvedir=1;
						else curvedir=0;
					}

					if (Input.mouseX>0 || Input.mouseY>0) {
						anchorx=anchorx+(Input.mouseX-anchorx)/4;
						anchory=anchory+(Input.mouseY-anchory)/4;
					}
					if (distanceToPoint(anchorx,anchory)>radius) {
						var xpre:Number=x;
						var ypre:Number=y;
						while (distanceToPoint(anchorx,anchory)>radius) moveTowards(anchorx,anchory,1);
						xspeed = x-xpre;
						yspeed = y-ypre;
						if (y<anchory) curvedir=1;
						else curvedir=0;
					}
				} else if (distanceToPoint(Input.mouseX,Input.mouseY)<150) {
					activated=true;
				}
			}
		}

		override public function render():void {
			if (!activated) Draw.circlePlus(x,y,150,0xFFFFFF,0.3);
			if (radius>0) {
				var d:Number = distanceToPoint(anchorx,anchory)/(radius);
				var curvey:Number = FP.scale(d,0,1,y+((curvedir) ? radius : -radius),(y+anchory)/2);
				Draw.curve(anchorx,anchory,(x+anchorx)/2,curvey,x,y,0xFFFFFF,1,3);
			}
			if (l.level<=3) {
				Draw.rect(x-size,y-size/2,size*2,size,0xFFFFFF);
				Draw.rect(x-size/2,y-size,size,size*2,0xFFFFFF);
			} else {
				Draw.graphic(img as Graphic,x-size,y-size);
			}
		}

		public function getArray():Array {
			var a:Array = [];
			a[0] = x;
			a[1] = y;
			a[2] = xspeed;
			a[3] = yspeed;
			a[4] = anchorx;
			a[5] = anchory;
			return a;
		}
	}
}
