﻿package  
{
	import net.flashpunk.World;
	import net.flashpunk.FP;
	import net.flashpunk.Sfx;
	import net.flashpunk.Graphic;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	import net.flashpunk.utils.Draw;
	import net.flashpunk.graphics.Text;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.utils.Data;
	import flash.net.*;

	[Embed(source = 'fonts/pixels.ttf', embedAsCFF="false", fontFamily = 'px')]
	//[Embed(source = 'fonts/pd.ttf', embedAsCFF="false", fontFamily = 'pd')]
	
	public class l_Level extends World
	{	
		[Embed(source = 'sfx/ded.mp3')]	private const DED:Class;
		[Embed(source = 'sfx/dead.mp3')]	private const DED2:Class;
		[Embed(source = 'sfx/loop.mp3')]	private const M:Class;
		[Embed(source = 'graphics/centerthing.png')] private const C:Class;
		[Embed(source = 'graphics/bg.png')] private const BG:Class;
		[Embed(source = 'graphics/bg2.png')] private const BG2:Class;

		public var _player:e_Player;
		public var _emitter:e_Particle;
		public var time:Number = 0;
		public var prevtime:Number = 0;
		public var dead:Boolean = false;
		public var level:Number = 1;

		public var olevel:Number = 1;
		public var bonus:Number = 0;

		public var a:Number = 1;
		public var rotspeed:Number = 0;
		public var circle:Number = 0;
		public var collight:Boolean = false;

		public var t1:Text;
		public var t2:Text;
		public var t3:Text;
		public var t4:Text;
		public var t5:Text;
		public var tt:Text;
		public var prevclear:Boolean = false;
		public var clear:Boolean = false;
		public var record:Number = 0;
		public var recbeat:Boolean = false;

		public var e1:Text;
		public var e2:Text;
		public var e3:Text;
		public var e4:Text;
		public var e5:Text;
		public var e6:Text;
		public var pos:Number = 0;

		public var img:Image;
		public var bg:Image;
		public var ded:Sfx;
		public var music:Sfx;

		public var parr:Array;
		public var inf:Number=1;

		public function l_Level(l:Number,pa:Array=null,ol:Number=0,b:Number=0) {
			FP.screen.color = 0x000000;
			level = l;
			if (ol==0) olevel = l;
			else {
				olevel = ol;
				bonus = b;
				clear = true;
			}

			img = new Image(C);
			img.centerOrigin();
			bg = new Image(BG);
			bg.centerOrigin();
			if (level<6) ded = new Sfx(DED);
			else {
				ded = new Sfx(DED2);
				music = new Sfx(M);
				music.loop(Math.floor(Math.random()*16)/16);
			}

			if (pa[0]) parr=pa;

			Data.load("data");
			record = Data.readInt("record"+olevel)/100;
			if (record>=30) clear=true;

			Text.font="px";
			Text.size=4;
			if (clear) {
				t1 = new Text(""+Math.floor(record));
				t2 = new Text(""+(Math.floor(record*100)%100));
				t3 = new Text("RECORD");
			} else {
				t1 = new Text("30");
				t2 = new Text("00");
				t3 = new Text("GOAL");
			}
			t1.size = 20;
			t1.align = "right";
			t2.size = 12;
			t3.size = 4;
			t4 = new Text("00");
			t4.size = 20;
			t4.align = "right";
			t5 = new Text("00");
			t5.size = 12;

			if (level==1) {
				tt = new Text("< MOVE");
				tt.size = 12;
			} else if (level>=5) {
				rotspeed=Math.random();
			}
		}
		
		public override function begin():void {
			super.begin();
			if (parr) _player = add(new e_Player(parr[0],parr[1],parr[2],parr[3],parr[4],parr[5])) as e_Player;
			else _player = add(new e_Player()) as e_Player;
			_emitter = add(new e_Particle()) as e_Particle;
		}
		
		public override function update():void {
			super.update();

			if (!dead) {
				if (level==5 && Math.random()<0.01) rotspeed=Math.random();
				if (level>=6 && Math.random()<0.02) rotspeed=Math.random()*2;
				img.angle+=rotspeed;

				if ((level==5 && Math.random()<0.06) || (level>=6 && Math.random()<0.15)) {
					var rd:Number=Math.random()*360;
					if (collight) {
						var c:Number = Math.round(Math.random()*4)
						if (c==0 || c==4) add(new e_Lightning(Math.cos(rd * (Math.PI / -180)) * 40 + 400,Math.sin(rd * (Math.PI / -180)) * 40 + 300,rd,0xFFFF00));
						else if (c==1) add(new e_Lightning(Math.cos(rd * (Math.PI / -180)) * 40 + 400,Math.sin(rd * (Math.PI / -180)) * 40 + 300,rd,0x0000FF));
						else if (c==2) add(new e_Lightning(Math.cos(rd * (Math.PI / -180)) * 40 + 400,Math.sin(rd * (Math.PI / -180)) * 40 + 300,rd,0x00FF00));
						else if (c==3) add(new e_Lightning(Math.cos(rd * (Math.PI / -180)) * 40 + 400,Math.sin(rd * (Math.PI / -180)) * 40 + 300,rd,0xFF0000));
					} else add(new e_Lightning(Math.cos(rd * (Math.PI / -180)) * 40 + 400,Math.sin(rd * (Math.PI / -180)) * 40 + 300,rd,0xFFFFFF));
				}

				prevtime=time;
				time+=FP.getElapsed(false);
				t4.text = ""+Math.floor(time+bonus);
				t5.text = ""+((Math.floor((time+bonus)*100)%100<10) ? "0" : "")+(Math.floor((time+bonus)*100)%100);
				if (time>=30 && !clear) {
					clear=true;
					recbeat=true;
					t2.text=t3.text="";
					t1.text="CLEAR";
					if (level>=6) {
						inf=1;
						bg = new Image(BG2);
						bg.centerOrigin();
						collight=true;
					}
					Data.load("data");
					if (Data.readInt("unlock",1)==olevel && olevel<7) {
						Data.writeInt("unlock",olevel+1);
						Data.save("data");
					}
				} else if (clear && time+bonus>record && !recbeat) {
					recbeat=true;
					t2.text=t3.text="";
					t1.text="NEW RECORD";
				}
				if (time>=60 && level<6) FP.world = new l_Level(level+1,_player.getArray(),olevel,time+bonus);

				if (time>=1) {
					if (level==1) {
						if (time<10) {
							if (prevtime<=6 && time>=6) add(new e_Enemy(-50,100,10,4));
						} else if (time<=20) {
							if ((prevtime<=10 && time>=10) || (prevtime<=12 && time>=12) || (prevtime<=14 && time>=14) || (prevtime<=16 && time>=16) || (prevtime<=18 && time>=18)) randomSpawn(10,2);
						} else if (time<30) {
							if (Math.ceil(prevtime)==Math.floor(time)) randomSpawn(10,1.5);
						} else {
							if (Math.ceil(prevtime)==Math.floor(time)) randomSpawn(10,1);
						}				
					} else if (level==2) {
						if (time<15) {
							if (Math.ceil(prevtime)==Math.floor(time)) randomSpawn(10+Math.random()*10,2);
						} else if (time<30) {
							if (Math.ceil(prevtime)==Math.floor(time)) randomSpawn(10+Math.random()*10,1.5);
						} else {
							if (Math.ceil(prevtime)==Math.floor(time)) randomSpawn(10+Math.random()*10,1);
						}		
					} else if (level==3) {
						if (time<30) {
							if (Math.ceil(prevtime)==Math.floor(time)) {
								randomSpawn(10+Math.random()*20,2.5);
								if (Math.floor(time)%5==0) randomSpawn(10+Math.random()*20,3.5);
							}
						} else {
							if (Math.ceil(prevtime)==Math.floor(time)) {
								randomSpawn(10+Math.random()*20,2.5);
								if (Math.floor(time)%3==0) randomSpawn(10+Math.random()*20,2.5);
							}
						}
					} else if (level==4) {
						if (time<30) {
							if (Math.ceil(prevtime)==Math.floor(time)) {
								randomSpawn(10+Math.random()*20,2);
								if (Math.floor(time)%5==0) randomSpawn(10+Math.random()*20,1.5);
							}
						} else {
							if (Math.ceil(prevtime)==Math.floor(time)) {
								randomSpawn(10+Math.random()*20,1.75);
								if (Math.floor(time)%2==0) randomSpawn(10+Math.random()*20,1.75);
							}
						}
					} else if (level==5) {
						if (time<30) {
							if (Math.ceil(prevtime)==Math.floor(time)) {
								randomSpawn(10+Math.random()*20,3);
								if (Math.floor(time)%8==0) randomSpawn(10+Math.random()*20,2);
								if (Math.floor(time)%4==0) randomSpawn(10+Math.random()*20,2);
							}
						} else {
							if (Math.ceil(prevtime)==Math.floor(time)) {
								randomSpawn(10+Math.random()*20,2);
								if (Math.floor(time)%6==0) randomSpawn(10+Math.random()*20,2);
								if (Math.floor(time)%2==0) randomSpawn(10+Math.random()*20,2);
							}
						}
					} else if (level==6) {
						if (time<20) {
							if (Math.ceil(prevtime*2)==Math.floor(time*2)) {
								randomSpawn(10+Math.random()*10,3.5);
								if (Math.floor(time)%4==0) randomSpawn(10+Math.random()*20,3);
								if (Math.floor(time)%12==0) randomSpawn(10+Math.random()*20,5);
							}
						} else if (time<=27.5) {
							if (Math.ceil(prevtime*2)==Math.floor(time*2)) {
								randomSpawn(10+Math.random()*10,2.5);
								if (Math.floor(time)%2==0) randomSpawn(10+Math.random()*20,5);
							}
						} else if (time<29) {
							if (Math.ceil(prevtime)==Math.floor(time)) {
								randomSpawn(10+Math.random()*10,2);
								randomSpawn(10+Math.random()*10,2);
								randomSpawn(10+Math.random()*10,2);
								randomSpawn(10+Math.random()*10,2);
								randomSpawn(10+Math.random()*10,2);
								randomSpawn(10+Math.random()*10,2);
							}
						} else if (time<60) {
							if (Math.ceil(prevtime)==Math.floor(time)) {
								randomSpawn(10+Math.random()*10,3.5);
								randomSpawn(10+Math.random()*10,3);
								if (Math.floor(time)%4==0) randomSpawn(10+Math.random()*20,2);
							}
						} else if (time<90) {
							if (Math.ceil(prevtime*2)==Math.floor(time*2)) {
								randomSpawn(10+Math.random()*10,2);
								if (Math.floor(time)%2==0) randomSpawn(10+Math.random()*20,4);
							}
						} else {
							if (Math.ceil(prevtime*2)==Math.floor(time*2)) {
								randomSpawn(10+Math.random()*20,Math.random()+0.5);
							}
						}
					} else if (level==7) {
						if (time<30) {
							if (Math.ceil(prevtime)==Math.floor(time)) {
								randomSpawn(10+Math.random()*20,2);
								if (Math.floor(time)%5==0) randomSpawn(10+Math.random()*20,1.5);
							}
						} else {
							if (Math.ceil(prevtime)==Math.floor(time)) {
								randomSpawn(10+Math.random()*20,1.75);
								if (Math.floor(time)%2==0) randomSpawn(10+Math.random()*20,1.75);
							}
						}
						if (Math.ceil(prevtime)==Math.floor(time) && Math.floor(time)%5==0) add(new e_PopUp());
					}
				}

				var list:Array = [];
				getClass(e_Enemy, list);
				for each (var e:e_Enemy in list) {
					if (!e.hit) {
						FP.rotateAround(e,400,300,rotspeed);
						if (e.distanceToPoint(400,300)<40) {
							if (level>=5) {
								_emitter.emit(e.x,e.y,e.xspeed*3,e.yspeed*3);
								_emitter.emit(e.x,e.y,e.xspeed,e.yspeed);
								_emitter.emit(e.x,e.y,-e.xspeed*3,-e.yspeed*3);
								_emitter.emit(e.x,e.y,-e.xspeed,-e.yspeed);
								_emitter.emit(e.x,e.y,e.xspeed*3,e.yspeed*3);
								_emitter.emit(e.x,e.y,e.xspeed,e.yspeed);
								_emitter.emit(e.x,e.y,-e.xspeed*3,-e.yspeed*3);
								_emitter.emit(e.x,e.y,-e.xspeed,-e.yspeed);
								FP.world.add(new e_BgCircle(e.x,e.y));
							}
							e.hit=true;
							e.xspeed*=-2;
							e.yspeed*=-2;
							dead=true;
							if (level>=3) ded.play();
							if (record<time+bonus) {
								Data.load("data");
								Data.writeInt("record"+olevel,Math.floor((time+bonus)*100));
								Data.save("data");
							}
							break;
						}
					}
				}
			} else {
				if (level>=6) music.stop();
				rotspeed=0;
				if (a>0) a-=0.02;
				if (pos == 0) {
					e1 = new Text("TIME");
					e1.size = 12;
					e2 = new Text(Math.floor(time+bonus)+":"+((Math.floor((time+bonus)*100)%100<10) ? "0" : "")+(Math.floor((time+bonus)*100)%100));
					e2.size = 28;
					if (time<record) {
						e3 = new Text("RECORD");
						e3.size = 12;
						e4 = new Text(Math.floor(record)+":"+((Math.floor((record)*100)%100<10) ? "0" : "")+(Math.floor(record*100)%100));
						e4.size = 28;
					} else {
						e3 = new Text("");
						e4 = new Text("NEW RECORD");
						e4.size = 28;
					}
					e5 = new Text("SPACE OR CLICK TO RESTART\nESCAPE TO GO BACK");
					e5.size = 8;
					if (record<30 && time+bonus>=30) {
						if (level==7) e6 = new Text("GAME COMPLETED");
						else e6 = new Text("NEW LEVEL UNLOCKED");
						e6.size = 28;
					} else if (level==6) {
						e6 = new Text("ENTER TO SUBMIT SCORE");
						e6.size = 28;
					}
					e1.align = e2.align = e3.align = e4.align = "right";
				}
				if (pos<1) pos+=0.05;
			}

			if (Input.pressed(Key.ENTER) && level==6) {
				//Highscore Submission removed to avoid hacking
			}
			if (Input.pressed(Key.SPACE) || Input.mousePressed) {
				var poc:Boolean=false;
				var listp:Array = [];
				getClass(e_PopUp, listp);
				for each (var po:e_PopUp in listp) {
					if (po.inW(Input.mouseX,Input.mouseY)) poc=true;
					if (po.inX(Input.mouseX,Input.mouseY)) remove(po);
				}
				if (poc) return;
				if (dead) FP.world = new l_Level(olevel,_player.getArray());
			}
			if (Input.pressed(Key.ESCAPE)) {
				if (dead) FP.world = new l_Menu(_player.getArray());
				else {
					dead=true;
					if (level>=3) ded.play();
					if (record<time+bonus) {
						Data.load("data");
						Data.writeInt("record"+olevel,Math.floor((time+bonus)*100));
						Data.save("data");
					}
				}
			} 

			if (inf>0) inf-=0.03;
		}

		public override function render():void {
			if (level<=3) {
				if (!dead) {
					Draw.rect(400-40,300-20,80,40,0xFFFFFF);
					Draw.rect(400-20,300-40,40,80,0xFFFFFF);
				} else if (level>1) {
					Draw.rect(400-40*a,300-20*a,80*a,40*a,0xFFFFFF,a);
					Draw.rect(400-20*a,300-40*a,40*a,80*a,0xFFFFFF,a);
				}
			} else {
				if (level>=5) {
					var list:Array = [];
					getClass(e_BgCircle, list);
					for each (var e:e_BgCircle in list) e.draw();
					if (level==5) {
						bg.scale = 4;
						bg.angle = img.angle;
						Draw.graphic(bg as Graphic,400,300);
					} else {
						bg.scale = 1;
						if (Math.ceil(prevtime*2)==Math.floor(time*2)) circle=1;
						if (circle>0) {
							circle-=0.05;
							Draw.circlePlus(400, 300, 300*-(circle-1), 0xFFFFFF, circle);
						}
						bg.angle = img.angle;
						Draw.graphic(bg as Graphic,400,300);
						if (circle>0) {
							img.alpha = circle;
							img.scale = 3-circle*2;
							Draw.graphic(img as Graphic,400,300);
						}
					}
				}
				img.alpha = a;
				img.scale = 2-a;
				Draw.graphic(img as Graphic,400,300);
			}

			super.render();

			if (level==1) {
				if (time<3) Draw.graphic(tt as Graphic,_player.x+26,_player.y-9);
				else if (time<6) {
					tt.text="< DEFEND";
					Draw.graphic(tt as Graphic,444,300-9);
				} else if (time<9) {
					tt.text="< BLOCK";
					var list:Array = [];
					getClass(e_Enemy, list);
					if (list[0]) Draw.graphic(tt as Graphic,list[0].x+13,list[0].y-9);
				}
			}

			if (!dead) {
				Draw.rect(0,0,5+t1.width+2+((t2.width>t3.width) ? t2.width : t3.width)+5+2,5+t1.height+5+2,0xFFFFFF);
				Draw.rect(0,0,5+t1.width+2+((t2.width>t3.width) ? t2.width : t3.width)+5,5+t1.height+5,0x000000);
				Draw.rect(800-(5+t4.width+2+t5.width+5)-2,0,5+t4.width+2+t5.width+5+2,5+t1.height+5+2,0xFFFFFF);
				Draw.rect(800-(5+t4.width+2+t5.width+5),0,5+t4.width+2+t5.width+5,5+t1.height+5,0x000000);

				Draw.graphic(t1 as Graphic,5,5);
				Draw.graphic(t2 as Graphic,5+t1.width+2,11);
				Draw.graphic(t3 as Graphic,5+t1.width+2,5);
				Draw.graphic(t4 as Graphic,800-5-t4.width-2-t5.width,5);
				Draw.graphic(t5 as Graphic,800-5-t5.width,11);
			} else if (e1) {
				Draw.rect(0,198,602*pos,36,0xFFFFFF);
				Draw.rect(0,200,600*pos,32,0x000000);
				Draw.rect(0,298,502*pos,36,0xFFFFFF);
				Draw.rect(0,300,500*pos,32,0x000000);
				Draw.rect(800-177*pos,498,177,24,0xFFFFFF);
				Draw.rect(800-175*pos,500,175,20,0x000000);
				if (e6) {
					Draw.rect(0,498,552*pos,36,0xFFFFFF);
					Draw.rect(0,500,550*pos,32,0x000000);
				}

				Draw.graphic(e1 as Graphic,598*pos-e1.width,200);
				Draw.graphic(e2 as Graphic,598*pos-e1.width-3-e2.width,200);
				Draw.graphic(e3 as Graphic,498*pos-e3.width,300);
				Draw.graphic(e4 as Graphic,498*pos-e3.width-3-e4.width,300);
				Draw.graphic(e5 as Graphic,800-175*pos+2,500);
				if (e6) Draw.graphic(e6 as Graphic,548*pos-e6.width,500);
			}

			if (inf>0 && level>3) Draw.rect(0,0,800,600,0xFFFFFF,inf);

			var list2:Array = [];
			getClass(e_PopUp, list2);
			list2.reverse();
			for each (var p:e_PopUp in list2) p.draw();
		}

		public function randomSpawn(s,t) {
			var d:Number = Math.round(Math.random()*4)
			if (d==0 || d==4) add(new e_Enemy(Math.random()*1000-100,-30,s,t));
			else if (d==1) add(new e_Enemy(Math.random()*1000-100,630,s,t));
			else if (d==2) add(new e_Enemy(-30,Math.random()*800-100,s,t));
			else if (d==3) add(new e_Enemy(830,Math.random()*800-100,s,t));
		}
	}
}
