﻿package  
{
	import net.flashpunk.World;
	import net.flashpunk.FP;
	import net.flashpunk.Sfx;
	import net.flashpunk.Graphic;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	import net.flashpunk.utils.Draw;
	import net.flashpunk.graphics.Text;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.utils.Data;

	[Embed(source = 'fonts/pixels.ttf', embedAsCFF="false", fontFamily = 'px')]
	//[Embed(source = 'fonts/pd.ttf', embedAsCFF="false", fontFamily = 'pd')]
	
	public class l_Menu extends World
	{
		[Embed(source = 'graphics/bg.png')] private const BG:Class;
	
		public var _player:e_Player;
		public var _lv1:e_Enemy;
		public var _lv2:e_Enemy;
		public var _lv3:e_Enemy;
		public var _lv4:e_Enemy;
		public var _lv5:e_Enemy;
		public var _lv6:e_Enemy;
		public var _lv7:e_Enemy;
		public var level:Number;

		public var bg:Image;
		public var t1:Text;
		public var t2:Text;
		public var t3:Text;

		public var l1:Text;
		public var l2:Text;
		public var l3:Text;
		public var l4:Text;
		public var l5:Text;
		public var l6:Text;
		public var l7:Text;

		public var parr:Array;
		public var inf:Number=1;

		public function l_Menu(pa:Array) {
			FP.screen.color = 0x000000;
			bg = new Image(BG);
			bg.centerOrigin();

			if (pa[0]) parr=pa;

			Text.font="px";
			t1 = new Text("MAXIMALISM");
			t1.size = 60;
			Text.size = 8;
			t2 = new Text("A 48 HOUR GAME BY SUYO (GREENCOUCHGAMES.NET)");
			t3 = new Text("MADE FOR LUDUM DARE #26 (LUDUMDARE.COM)");
		}
		
		public override function begin():void {
			super.begin();
			Data.load("data");
			level = Data.readInt("unlock",1);

			if (parr) _player = add(new e_Player(parr[0],parr[1],parr[2],parr[3],parr[4],parr[5])) as e_Player;
			else _player = add(new e_Player(400,300,0,0,400,300,false)) as e_Player;

			var r:Number;
			switch(level) {
				case 7:	
					_lv7 = add(new e_Enemy(400,530,20,0)) as e_Enemy;
					r = Data.readInt("record7",0);
					l7 = new Text("SECRET LEVEL\n\n"+((r!=0) ? "BEST "+Math.floor(r/100)+":"+(r%100) : "FUCK YEAH!"));
				case 6:	
					_lv6 = add(new e_Enemy(600,500-10,20,0)) as e_Enemy;
					r = Data.readInt("record6",0);
					l6 = new Text("LEVEL 6\n\n"+((r!=0) ? "BEST "+Math.floor(r/100)+":"+(r%100) : ""));
				case 5:	
					_lv5 = add(new e_Enemy(200,500-10,20,0)) as e_Enemy;
					r = Data.readInt("record5",0);
					l5 = new Text("LEVEL 5\n\n"+((r!=0) ? "BEST "+Math.floor(r/100)+":"+(r%100) : "NEED 30:00"));
					l5.align="right";
				case 4:	
					_lv4 = add(new e_Enemy(700,300-10,20,0)) as e_Enemy;
					r = Data.readInt("record4",0);
					l4 = new Text("LEVEL 4\n\n"+((r!=0) ? "BEST "+Math.floor(r/100)+":"+(r%100) : "NEED 30:00"));
				case 3:	
					_lv3 = add(new e_Enemy(100,300-10,20,0)) as e_Enemy;
					r = Data.readInt("record3",0);
					l3 = new Text("LEVEL 3\n\n"+((r!=0) ? "BEST "+Math.floor(r/100)+":"+(r%100) : "NEED 30:00"));
					l3.align="right";
				case 2:	
					_lv2 = add(new e_Enemy(600,100-10,20,0)) as e_Enemy;
					r = Data.readInt("record2",0);
					l2 = new Text("LEVEL 2\n\n"+((r!=0) ? "BEST "+Math.floor(r/100)+":"+(r%100) : "NEED 30:00"));
				default:	
					_lv1 = add(new e_Enemy(200,100-10,20,0)) as e_Enemy;
					r = Data.readInt("record1",0);
					l1 = new Text("LEVEL 1\n\n"+((r!=0) ? "BEST "+Math.floor(r/100)+":"+(r%100) : "NEED 30:00"));
					l1.align="right";
			}
		}
		
		public override function update():void {
			super.update();

			switch(level) {
				case 7:	if (_lv7.hit) FP.world = new l_Level(7,_player.getArray());
				case 6:	if (_lv6.hit) FP.world = new l_Level(6,_player.getArray());
				case 5:	if (_lv5.hit) FP.world = new l_Level(5,_player.getArray());
				case 4:	if (_lv4.hit) FP.world = new l_Level(4,_player.getArray());
				case 3:	if (_lv3.hit) FP.world = new l_Level(3,_player.getArray());
				case 2:	if (_lv2.hit) FP.world = new l_Level(2,_player.getArray());
				default:if (_lv1.hit) FP.world = new l_Level(1,_player.getArray());
			}

			if (inf>0) inf-=0.01;

			if (Input.pressed(Key.R)) {
				Data.load("data");
				Data.writeInt("unlock",1);
				Data.writeInt("record1",0);
				Data.writeInt("record2",0);
				Data.writeInt("record3",0);
				Data.writeInt("record4",0);
				Data.writeInt("record5",0);
				Data.writeInt("record6",0);
				Data.writeInt("record7",0);
				Data.save("data");
				FP.world = new l_Menu([]);
			}
			if (Input.pressed(Key.SPACE)) {
				Data.load("data");
				Data.writeInt("unlock",7);
				Data.save("data");
				FP.world = new l_Menu([]);
			}
		}

		public override function render():void {
			if (level>=5) {
				if (level==5) bg.scale=4;
				else bg.scale=1;
				bg.angle+=0.1;
				Draw.graphic(bg as Graphic,400,300);
			}

			Draw.graphic(t1 as Text,410-t1.width/2,300-t1.height/2);
			Draw.graphic(t2 as Text,410-t2.width/2,340);
			Draw.graphic(t3 as Text,410-t3.width/2,350);

			switch(level) {
				case 7:	Draw.graphic(l7 as Text,400-l7.width/2,475);
				case 6:	Draw.graphic(l6 as Text,620,475);
				case 5:	Draw.graphic(l5 as Text,180-l5.width,475);
				case 4:	Draw.graphic(l4 as Text,720,275);
				case 3:	Draw.graphic(l3 as Text,80-l3.width,275);
				case 2:	Draw.graphic(l2 as Text,620,75);
				default:Draw.graphic(l1 as Text,180-l1.width,75);
			}

			super.render();

			if (inf>0 && level>3) Draw.rect(0,0,800,600,0xFFFFFF,inf);
		}
	}
}
